/* Utils.c generated by valac 0.39.7, the Vala compiler
 * generated from Utils.vala, do not modify */

/**/
/*  Copyright (C) 2015 Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))



GSettings* plank_create_settings (const gchar* schema_id,
                                  const gchar* path);
GSettings* plank_try_create_settings (const gchar* schema_id,
                                      const gchar* path);
gchar** plank_string_split_combine (const gchar* s,
                                    const gchar* delimiter,
                                    int* result_length1);
void plank_combine_strings (gchar*** _result_,
                            int* _result__length1,
                            const gchar* delimiter,
                            gint n,
                            gint i);
gboolean plank_file_is_dockitem (GFile* file);
gdouble plank_nround (gdouble d,
                      guint n);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
 * Creates a new {@link GLib.Settings} object with a given schema and path.
 *
 * It is fatal if no schema to the given schema_id is found!
 *
 * If path is NULL then the path from the schema is used. It is an error if
 * path is NULL and the schema has no path of its own or if path is non-NULL
 * and not equal to the path that the schema does have.
 *
 * @param schema_id a schema ID
 * @param path the path to use
 * @return a new GLib.Settings object
 */
GSettings*
plank_create_settings (const gchar* schema_id,
                       const gchar* path)
{
	GSettings* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GSettingsSchema* schema = NULL;
	GSettingsSchemaSource* _tmp4_;
	GSettingsSchema* _tmp5_;
	GSettings* _tmp6_;
	g_return_val_if_fail (schema_id != NULL, NULL);
	_tmp0_ = g_get_current_dir ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strconcat (_tmp1_, "/data", NULL);
	_tmp3_ = _tmp2_;
	g_setenv ("GSETTINGS_SCHEMA_DIR", _tmp3_, FALSE);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	_tmp4_ = g_settings_schema_source_get_default ();
	_tmp5_ = g_settings_schema_source_lookup (_tmp4_, schema_id, TRUE);
	schema = _tmp5_;
	if (schema == NULL) {
		g_error ("Utils.vala:42: GSettingsSchema '%s' not found", schema_id);
	}
	_tmp6_ = g_settings_new_full (schema, NULL, path);
	result = _tmp6_;
	_g_settings_schema_unref0 (schema);
	return result;
}


/**
 * Tries to create a new {@link GLib.Settings} object with a given schema and path.
 *
 * If path is NULL then the path from the schema is used. It is an error if
 * path is NULL and the schema has no path of its own or if path is non-NULL
 * and not equal to the path that the schema does have.
 *
 * @param schema_id a schema ID
 * @param path the path to use
 * @return a new GLib.Settings object or NULL
 */
GSettings*
plank_try_create_settings (const gchar* schema_id,
                           const gchar* path)
{
	GSettings* result = NULL;
	GSettingsSchema* schema = NULL;
	GSettingsSchemaSource* _tmp0_;
	GSettingsSchema* _tmp1_;
	GSettingsSchema* _tmp2_;
	GSettingsSchema* _tmp3_;
	GSettings* _tmp4_;
	g_return_val_if_fail (schema_id != NULL, NULL);
	_tmp0_ = g_settings_schema_source_get_default ();
	_tmp1_ = g_settings_schema_source_lookup (_tmp0_, schema_id, TRUE);
	schema = _tmp1_;
	_tmp2_ = schema;
	if (_tmp2_ == NULL) {
		g_warning ("Utils.vala:62: GSettingsSchema '%s' not found", schema_id);
		result = NULL;
		_g_settings_schema_unref0 (schema);
		return result;
	}
	_tmp3_ = schema;
	_tmp4_ = g_settings_new_full (_tmp3_, NULL, path);
	result = _tmp4_;
	_g_settings_schema_unref0 (schema);
	return result;
}


/**
 * Generates an array containing all combinations of a splitted strings parts
 * while preserving the given order of them.
 *
 * @param s a string
 * @param delimiter a delimiter string
 * @return an array of concated strings
 */
gchar**
plank_string_split_combine (const gchar* s,
                            const gchar* delimiter,
                            int* result_length1)
{
	gchar** result = NULL;
	gchar** parts = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint parts_length1;
	gint _parts_size_;
	gint count = 0;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** _result_ = NULL;
	gint _tmp3_;
	gint _tmp4_;
	gchar** _tmp5_;
	gint _result__length1;
	gint __result__size_;
	gint pos = 0;
	gint _tmp20_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	g_return_val_if_fail (s != NULL, NULL);
	g_return_val_if_fail (delimiter != NULL, NULL);
	_tmp1_ = _tmp0_ = g_strsplit (s, delimiter, 0);
	parts = _tmp1_;
	parts_length1 = _vala_array_length (_tmp0_);
	_parts_size_ = parts_length1;
	_tmp2_ = parts;
	_tmp2__length1 = parts_length1;
	count = _tmp2__length1;
	_tmp3_ = count;
	_tmp4_ = count;
	_tmp5_ = g_new0 (gchar*, ((_tmp3_ * (_tmp4_ + 1)) / 2) + 1);
	_result_ = _tmp5_;
	_result__length1 = (_tmp3_ * (_tmp4_ + 1)) / 2;
	__result__size_ = _result__length1;
	pos = 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp6_ = FALSE;
			_tmp6_ = TRUE;
			while (TRUE) {
				gint _tmp8_;
				gint _tmp9_;
				gchar** _tmp10_;
				gint _tmp10__length1;
				gint _tmp11_;
				gchar** _tmp12_;
				gint _tmp12__length1;
				gint _tmp13_;
				const gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
				if (!_tmp6_) {
					gint _tmp7_;
					_tmp7_ = i;
					i = _tmp7_ + 1;
				}
				_tmp6_ = FALSE;
				_tmp8_ = i;
				_tmp9_ = count;
				if (!(_tmp8_ < _tmp9_)) {
					break;
				}
				_tmp10_ = _result_;
				_tmp10__length1 = _result__length1;
				_tmp11_ = pos;
				_tmp12_ = parts;
				_tmp12__length1 = parts_length1;
				_tmp13_ = i;
				_tmp14_ = _tmp12_[_tmp13_];
				_tmp15_ = g_strdup (_tmp14_);
				_g_free0 (_tmp10_[_tmp11_]);
				_tmp10_[_tmp11_] = _tmp15_;
				_tmp16_ = _tmp10_[_tmp11_];
				_tmp17_ = pos;
				_tmp18_ = count;
				_tmp19_ = i;
				pos = _tmp17_ + (_tmp18_ - _tmp19_);
			}
		}
	}
	_tmp20_ = count;
	plank_combine_strings (&_result_, &_result__length1, delimiter, 0, _tmp20_);
	_tmp21_ = _result_;
	_tmp21__length1 = _result__length1;
	if (result_length1) {
		*result_length1 = _tmp21__length1;
	}
	result = _tmp21_;
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


void
plank_combine_strings (gchar*** _result_,
                       int* _result__length1,
                       const gchar* delimiter,
                       gint n,
                       gint i)
{
	gint pos = 0;
	g_return_if_fail (delimiter != NULL);
	if (i <= 1) {
		return;
	}
	pos = n;
	{
		gint j = 0;
		j = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				const gchar* _tmp7_;
				gint _tmp8_;
				const gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = j;
					j = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = j;
				if (!(_tmp2_ < (i - 1))) {
					break;
				}
				_tmp3_ = pos;
				_tmp4_ = j;
				pos = _tmp3_ + (i - _tmp4_);
				_tmp5_ = j;
				_tmp6_ = j;
				_tmp7_ = (*_result_)[n + _tmp6_];
				_tmp8_ = pos;
				_tmp9_ = (*_result_)[_tmp8_];
				_tmp10_ = g_strdup_printf ("%s%s%s", _tmp7_, delimiter, _tmp9_);
				_g_free0 ((*_result_)[(n + _tmp5_) + 1]);
				(*_result_)[(n + _tmp5_) + 1] = _tmp10_;
				_tmp11_ = (*_result_)[(n + _tmp5_) + 1];
			}
		}
	}
	plank_combine_strings (_result_, _result__length1, delimiter, n + i, i - 1);
}


/**
 * Whether the given file looks like a valid .dockitem file
 */
inline gboolean
plank_file_is_dockitem (GFile* file)
{
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (file != NULL, FALSE);
	{
		GFileInfo* info = NULL;
		GFileInfo* _tmp0_;
		gboolean _tmp1_ = FALSE;
		_tmp0_ = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_IS_HIDDEN, 0, NULL, &_inner_error_);
		info = _tmp0_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch1_g_error;
		}
		if (!g_file_info_get_is_hidden (info)) {
			const gchar* _tmp2_;
			_tmp2_ = g_file_info_get_name (info);
			_tmp1_ = g_str_has_suffix (_tmp2_, ".dockitem");
		} else {
			_tmp1_ = FALSE;
		}
		result = _tmp1_;
		_g_object_unref0 (info);
		return result;
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_warning ("Utils.vala:119: %s", _tmp4_);
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gboolean _tmp5_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp5_;
	}
	result = FALSE;
	return result;
}


inline gdouble
plank_nround (gdouble d,
              guint n)
{
	gdouble result = 0.0;
	gdouble _result_ = 0.0;
	if (n > 0U) {
		gdouble fac = 0.0;
		gdouble _tmp0_;
		gdouble _tmp1_;
		fac = pow (10.0, (gdouble) n);
		_tmp0_ = fac;
		_tmp1_ = fac;
		_result_ = round (d * _tmp0_) / _tmp1_;
	} else {
		_result_ = round (d);
	}
	result = _result_;
	return result;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



